<template>
  <div class="eliminar-propuesta">
    <div v-if="error" class="error">
      <template v-if="error === 'unprocessable_entity'">
        No se puede eliminar esta propuesta por que ya tiene posiciones.
        <router-link :to="`/barcas/${barcaId}/consensos/${id}`"
          >Volver al consenso</router-link
        >
      </template>
      <template v-else>
        {{ error }}
      </template>
    </div>
    <template v-if="loading">
      <h1>cargando propuesta...</h1>
    </template>
    <template v-else-if="consenso">
      <h1>Eliminar propuesta</h1>
      <p>¿Estás segurx de que querés borrar esta propuesta?</p>
      <div class="consenso-wrapper">
        <consenso :consenso="consenso" :sinBarra="true" />
      </div>
      <custom-button @click="eliminar" :loading="deleting">
        Eliminar propuesta
      </custom-button>
    </template>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import Consenso from '@/components/Consenso'
import CustomButton from '@/components/Button.vue'

export default {
  name: 'EliminarPropuesta',
  components: { Consenso, CustomButton },
  data() {
    return { deleting: false, error: null, loading: !!this.consenso }
  },
  methods: {
    eliminar() {
      this.deleting = true
      return this.$store
        .dispatch('eliminarConsenso', {
          consensoId: this.id,
          barcaId: this.barcaId,
        })
        .then(() => this.$router.push(`/barcas/${this.barcaId}`))
        .catch(err => (this.error = err))
        .finally(() => (this.deleting = false))
    },
    refrescar(init = false) {
      this.error = null
      if (!init) this.loading = true
      return this.$store
        .dispatch('conseguirConsenso', {
          consensoId: this.id,
          barcaId: this.barcaId,
        })
        .catch(error => (this.error = error))
        .finally(() => (this.loading = false))
    },
  },
  mounted() {
    this.refrescar(this.loading)
  },
  computed: {
    id() {
      return this.$route.params.id
    },
    barcaId() {
      return this.$route.params.barcaId
    },
    ...mapState({
      consenso(state) {
        return state.consensos.find(consenso => consenso.id === Number(this.id))
      },
    }),
  },
}
</script>

<style lang="sass" scoped>
.eliminar-propuesta
  margin: 10px 20px
.consenso-wrapper
  border: 2px solid black
</style>
